PIPE(2)

NAME
pipe - create descriptor pair for interprocess communication

SYNOPSIS
#include <unistd.h>
int
pipe(int fildes[2]);

DESCRIPTION
The pipe() function creates a pipe, which is an object allowing unidirectional data flow, and allocates a pair of file descriptors. The first descriptor connects to the read end of the pipe, and the second connects to the write end, so that data written to fildes[1] appears on (i.e., can be read from) fildes[0]. This allows the output of one program to be sent to another program: the source's standard output is set up to be the write end of the pipe, and the sink's standard input is set up to be the read end of the pipe. The pipe itself persists until all its associated descriptors are closed.

A pipe whose read or write end has been closed is considered widowed. Writing on such a pipe causes the writing process to receive a SIGPIPE signal. Widowing a pipe is the only way to deliver end-of-file to a reader: after the reader consumes any buffered data, reading a widowed pipe returns a zero count.

RETURN VALUES
On successful creation of the pipe, zero is returned. Otherwise, a value of -1 is returned and the variable errno set to indicate the error.

ERRORS
The pipe() call will fail if:

[EMFILE]
    Too many descriptors are active.

[ENFILE]
    The system file table is full.

[EFAULT]
    The fildes buffer is in an invalid area of the process's address space.

SEE ALSO
sh(1), fork(2), read(2), socketpair(2), write(2)

STANDARDS
The pipe() function conforms to p1003.1-2008.

As an extension, the pipe provided is actually capable of moving data bidirectionally. This is compatible with SVR4. However, this is non-POSIX behaviour which should not be relied on, for reasons of portability.

HISTORY
A pipe() function call appeared in AT&T UNIX. Since AT&T UNIX, it allocates two distict file descriptors.